C   MODIFIED VERSION OF THE SAMPLE PROGRAM IN THE INITIAL COMMENTS FOR
C   AQUAD.F.
C						K.R.J.    16 Nov 1988
C						modified  23 Mar 1992
C
C  *************************
C  *
C  *  THIS PROGRAM USES THE TEAPACK ADAPTIVE QUADRATURE ROUTINE DAQUAD 
C  *  TO APPROXIMATE THE VALUE OF I(F;A,B).  IN THIS EXAMPLE, THE BASIC
C  *  INTEGRATION FORMULA USED IS THE 2-POINT GAUSS-LEGENDRE RULE, THE 
C  *  COEFFICIENTS'S OF WHICH ARE GIVEN IN THE TEAPACK ROUTINE DGLEGQ.
C  *
C  *  IF YOU RUN THIS PROGRAM ON A SUN, COMPILE IT WITH 
C  *         f77 example.f daquad.f dquad.f dglegq.f
C  *
C  ************************
C
      DOUBLE PRECISION A,B,TOL,APPROX,SING,ERREST,F,DAQUAD
      EXTERNAL F,DGLEGQ

C     LOOP
 10   CONTINUE

         WRITE (6,1) ' TYPE A,B,TOL TO INTEGRATE',
     +               ' OR 0 0 0 TO TERMINATE:'
 1       FORMAT(/// 2A )
         READ (5,*) A,B,TOL

         IF (A .EQ. 0.D0 .AND. B .EQ. 0.D0 .AND. TOL .EQ. 0.D0) STOP
   
         WRITE (6,2) ' A = ', A, '   B = ', B, '   TOL = ', TOL
 2       FORMAT ( /// 3(A,1PD15.5))

         MAXLEV = 30
   
         APPROX = DAQUAD(DGLEGQ,2,F,A,B,TOL,MAXLEV,SING,ERREST)
   
         IF (TOL .NE. 0.D0) WRITE (6,*) 'ROUTINE FAILED. TOL = ',TOL,
     +                                  '  SING = ',SING
   
         WRITE (6,3) ' APPROXIMATE VALUE OF INTEGRAL = ',APPROX,
     +               ' ERROR ESTIMATE = ',ERREST,
     +               ' # SUBINTERVALS USED = ',MAXLEV,
     +               ' TRUE VALUE OF INTEGRAL = ',EXP(B) - EXP(A),
     +               ' TRUE ERROR = ',(EXP(B) - EXP(A)) - APPROX
 3       FORMAT ( A,1PD15.5 / A,1PD15.5 / A,I5, 2(/A,1PD15.5) )

      GOTO 10
C     END LOOP

      END



      DOUBLE PRECISION FUNCTION F(X)
      DOUBLE PRECISION X
     
      F = EXP(X)
	
      RETURN
      END
